#ifndef _SIP_UTILITY_H
#define _SIP_UTILITY_H

#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<sys/types.h>
#include<unistd.h>

#include<netdb.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<sys/time.h>

#define MAX_MESSAGE          21000      /* SIPåκʸ */
#define MAX_FIELD            1024       /* إåե1Ԥκʸ */
#define SIP_PORT             5060       /* SIPǻѤݡֹ */
#define SIP_VERSION          "SIP/2.0"  /* SIPΥС */
#define PROTOCOL_UDP         "UDP"      /* åžѥץȥ */
#define MAX_COUNT            70         /* Max-Frowards */
#define MAX_NAME             256        /* ۥ̾κʸ */
#define MAX_EXPIRES          7200       /* REGISTERͭ */
#define UNREGISTER_EXPIRES   0          /* ϿѤExpires */
#define ADDR_SIZE            16         /* IPɥ쥹κĹ */
#define CONFIG_FILE_NAME     "sip.conf"
#define CONTENT_TYPE         "application/sdp"
#define IP_TYPE              "IP4"

#define HEADER_VIA           "Via: "
#define HEADER_MAXFORWARDS   "Max-Forwards: "
#define HEADER_FROM          "From: "
#define HEADER_TO            "To: "
#define HEADER_CALLID        "Call-ID: "
#define HEADER_CSEQ          "CSeq: "
#define HEADER_CONTACT       "Contact: "
#define HEADER_CONTENTTYPE   "Content-Type: "
#define HEADER_CONTENTLENGTH "Content-Length: "
#define HEADER_EXPIRES       "Expires: "

#define METHOD_REGISTER      "REGISTER"
#define METHOD_INVITE        "INVITE"
#define METHOD_TRYING        "100 Trying"
#define METHOD_RINGING       "180 Ringing"
#define METHOD_ACK           "ACK"
#define METHOD_OK            "200 OK"
#define METHOD_BYE           "BYE"
#define METHOD_CANCEL        "CANCEL"
#define METHOD_BUSY          "486 Busy Here"
#define METHOD_TERMINATE     "487 Request Terminate"

#define CODEC_AUDIO          "PCMU"     /* G.711 */
#define AUDIO_RATE           8000       /* 8000samples/sec */
#define RTPTYPE              0          /* PCMUΥڥɥ */

#define RANDOM(x)            (rand()%(x))

#define debug(s)             printf(s)

/* SIPлѡ̤Ѥζ */
enum registerflag{
    eRNull = 0,             /* ̤ */
    eRRegister,             /* ѤƤ */
};

/* ȯԡ忮Ԥζ */
enum callflag{
    eCNull = 0,             /*  */
    eCSender,               /* ȯ */
    eCReceiver              /* 忮 */
};

/* RTP */
enum send_flag{
    null = 0,
    ok ,
    ng 
};

/* SIPåξ */
enum callstate{
    eSNull = 0,             /*  */
    eSRegister,             /* REGISTER */
    eSIdle,                 /* REGISTERλ */
    eSWaitBusy,             /* ³ */
    eSBusy,                 /*  */
    eSWaitDisc,             /* ǽ */
    eSUnRegister            /* REGISTER */
};

/* SIPåΥ᥽å */
enum method{
    Method_Register = 0,    /* REGISTER */
    Method_Invite,          /* INVITE */
    Method_Ack,             /* ACK */
    Method_Bye,             /* BYE */
    Method_Cancel,          /* CANCEL */
    Method_Trying,          /* 100 Trying */
    Method_Ringing,         /* 180 Ringing */
    Method_OK,              /* 200 OK */
    Method_Busy,            /* 486 Busy Here */
    Method_RequestTerminate /* 487 Request Terminate */
};

/* åƤǼ빽¤ */
typedef struct{
    char save_Msg[MAX_MESSAGE];      /* SIPå */
    char save_beforMsg[MAX_MESSAGE]; /* 󥹤1¸SIPå */
    char save_Via[MAX_FIELD];        /* ¸Viaإå */
    char save_Via2nd[MAX_FIELD];     /* ¸Viaإå2 */
    char save_From[MAX_FIELD];       /* ¸From */
    char save_To[MAX_FIELD];         /* ¸To */
    char save_CallID[MAX_FIELD];     /* ¸Call-ID */
    char save_Cseq[MAX_FIELD];       /* ¸CSeq */
}SAVE_MSG;

/* å */
typedef struct{
    enum registerflag   server_flag; /* лȽ */
    enum callflag   session_flag;    /* ȯȽѥե饰 */
    enum callstate  state;           /* SIPåξ */
    char username[MAX_NAME];         /* ü桼̾ */
    char fqdn[MAX_NAME];             /* üFQDN */
    char addr[ADDR_SIZE];            /* üIPɥ쥹 */
    char serv_addr[ADDR_SIZE];       /* SIPФIPɥ쥹 */
    char serv_fqdn[MAX_NAME];        /* SIPФFQDN */
    struct in_addr  partner;         /* SIPüIPɥ쥹 */
    char rtp_addr[ADDR_SIZE];        /* RTPüIPɥ쥹 */
    int seq;                         /* ֹ */
    int rtpport;                     /* ̿˻Ѥݡֹ */
    char y_rtpport[10];              /* üβ̿˻Ѥݡֹ */
}STACK_INFO;

typedef struct{
    int sock;
    SAVE_MSG* pmsg;
    STACK_INFO* pinfo;
    enum send_flag* psend_switch;
}RECV_INFO;

#endif
