#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <linux/soundcard.h>
#include "sound.h"

/* ɥǥХΥեǥץ */
int g_fdp;
int g_fdr;

int open_soundr(void){
    int arg;  /* I/OȥѤѿ */
    int status;   /* ƥॳξ֤֤ѿ */

    /* ɥǥХ򳫤 */
    g_fdr = open("/dev/dsp", O_RDONLY);
    if (g_fdr < 0){
        perror("open of /dev/dsp failed");
        return -1;
    }

    /* ץ󥰥ѥ᡼ */
    arg = AFMT_S16_NE;       /* ǥեޥå */
    status = ioctl(g_fdr, SNDCTL_DSP_SETFMT, &arg);
    if (status == -1) perror("SNDCTL_DSP_SETFMT ioctl failed");
    if (arg != AFMT_S16_NE) perror("unable to set FORMAT");

    /* ץ󥰥 */
    arg = SIZE;
    status = ioctl(g_fdr, SOUND_PCM_READ_BITS, &arg);
    if (status == -1) perror("SOUND_PCM_READ_BITS ioctl failed");
    if (arg != SIZE) perror("READ unable to set sample size");

    /* Υ뤫ƥ쥪 */
    arg = CHANNELS;
    status = ioctl(g_fdr, SOUND_PCM_READ_CHANNELS, &arg);
    if (status == -1) perror("SOUND_PCM_READ_CHANNELS ioctl failed");
    if (arg != CHANNELS) perror("READ unable to set number of channels");

    arg = RATE;      /* ץ󥰥졼 */
    status = ioctl(g_fdr, SOUND_PCM_READ_RATE, &arg);
    if (status == -1) perror("SOUND_PCM_READ_RATE ioctl failed");
    return 0; 
}

int open_soundp(){
    int arg;       /* I/OȥѤѿ */
    int status;    /* ƥॳξ֤֤ѿ */

    /* ɥǥХ򳫤 */
    g_fdp = open("/dev/dsp", O_WRONLY);
    if (g_fdp < 0) {
        perror("open of /dev/dsp failed");
        return -1;
    }

    /* ץ󥰥ѥ᡼ */
    arg = AFMT_S16_NE;       /* ǥեޥå */
    status = ioctl(g_fdp, SNDCTL_DSP_SETFMT, &arg);
    if(status == -1) perror("SND_DSP_SETFMT ioctl failed");
    if (arg != AFMT_S16_NE) perror("unable to set FOMAT");

    arg = SIZE;      /* ץ󥰥 */
    status = ioctl(g_fdp, SOUND_PCM_WRITE_BITS, &arg);
    if (status == -1) perror("SOUND_PCM_WRITE_BITS ioctl failed");
    if (arg != SIZE) perror("WRITE unable to set sample size");

    arg = CHANNELS;  /* Υ뤫ƥ쥪 */
    status = ioctl(g_fdp, SOUND_PCM_WRITE_CHANNELS, &arg);
    if (status == -1) perror("SOUND_PCM_WRITE_CHANNELS ioctl failed");
    if (arg != CHANNELS) perror("WRITE unable to set number of channels");

    arg = RATE;      /* ץ󥰥졼 */
    status = ioctl(g_fdp, SOUND_PCM_WRITE_RATE, &arg);
    if (status == -1) perror("SOUND_PCM_WRITE_WRITE ioctl failed");

    return 0; 
}

int play_sound(short* buf){
    int status;   /* ƥॳξ֤֤ѿ */

    status = write(g_fdp, buf, AUDIO_BUFF_SIZE*2); /* Ͽ */
    if (status != AUDIO_BUFF_SIZE*2){
        return 1;
    }

    status = ioctl(g_fdp, SOUND_PCM_SYNC, 0 );
    if (status == -1){
        perror("SOUND_PCM_SYNC ioctl failed");
    return 1;
    }
    return 0;
}

int record_sound(short* buf){
    int status;                       /* ƥॳξ֤֤ѿ */

    status = read(g_fdr, buf, AUDIO_BUFF_SIZE*2); /* Ͽ */
    if (status != AUDIO_BUFF_SIZE*2){
        return 1;
    }
    return 0;
}

int close_soundp(void){
    close(g_fdp);            /* ɥǥХĤ */

    return 0;
}

int close_soundr(void){
    close(g_fdr);            /* ɥǥХĤ */
    return 0;
}
